/*******************************************************
 
Author : Mauro Laurenti
Version : 1.0
Date : 02/10/2006
 
CopyRight 2007 all rights are reserved


********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) 
is intended for use solely and exclusively on Microchip PIC Microcontroller (registred mark).  
The software is owned by the Author, and is protected under applicable copyright laws. 
All rights are reserved. 
Any use in violation of the foregoing restrictions may subject the 
user to criminal sanctions under applicable laws (Italian or International ones), as well as to 
civil liability for the breach of the terms and conditions of this license. 
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the following 
software doesn't aim to commercial use or monetary earning of any kind.    

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT, 
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************
PURPOSES
********************************************************
 
 
 Controllo di 16 Carichi con la seriale del PC
 
 Visita www.LaurTec.com per ulteriori informazioni 

 *******************************************************/
 
// variabili globali

unsigned char valPORTB = 0;	//variabili associate alle porte di uscita
unsigned char valPORTD = 0; 
 
//includo le librerie 
 
#include <p18f4580.h>
#include <usart.h>
#include <timers.h> 
 
#pragma config OSC = HS 		// 20Mhz
#pragma config WDT = OFF 		// disattivo il watchdog timer
#pragma config LVP = OFF 		// disattivo la programmazione LVP
#pragma config PBADEN = OFF 	// disabilito gli ingressi analogigi sulla PORTB


//funzione per il ritardo
void Delay (int time)
{	int i;
	int j;

	for (j=0; j<time;j++)
		for (i=0; i<12000; i++);
}

//funzione per generare un beep con il cicalino
void beep ()
{	int i;
	
	PORTEbits.RE1 = 1;
	Delay (2);
	PORTEbits.RE1 = 0;
}



 void Low_Int_Event (void); 		// prototipo di funzione


 #pragma code low_vector=0x18

 void low_interrupt (void)
 {
 	_asm GOTO Low_Int_Event _endasm //imposta il salto per la gestione

 }

 #pragma code

 #pragma interrupt Low_Int_Event

 void Low_Int_Event (void)
 { 	int i; // variabile generica
	static unsigned char counter = 0;		//conatore byte ricevuti per il comando
	static unsigned char ResetUSART = 0;	// Flag per controllare il Time out in ricezione 
	static unsigned char data [5];			// variabile che conterr i dati ricevuti
	static unsigned char num =0;			// variabile per il conteggio degli interrupt
	unsigned char tamp1 = 0;				// variabili per la conversione carattere numero
	unsigned char tamp2 = 0;
	unsigned char tamp3 = 0;
	
		
	if (PIR1bits.RCIF == 1 )			// Controllo che l'interrupt sia stato generato dall'USART 
	{					
		data[counter] = ReadUSART(); 	// leggo il dato dal buffer di ricezione
		
 		counter++;	//incremento il numero di byte ricevuti
 		
 		if (counter > 4)	//quando ricevo 5 byte decodifico il comando ricevuto
 		{				
	 		for (i=0;i<5; i++)
				{
					WriteUSART(data[i]);  	// ritrasmetto il dato ricevuto
					while (BusyUSART());	// attendo che il dato venga trasmesso	
				}
				WriteUSART(13);			// invio carattere ritorno a capo
					 
				if (data[0] == 'T')			//riporto in uscita i valori letti
					{	
						if (data[1]-48 > 9)
							tamp1 = data[1]-55;	// ho una lettera
						else
							tamp1 = data[1]-48;
				
						if (data[2]-48 > 9)
							tamp2 = data[2]-55;// ho una lettera
						else
							tamp2 = data[2]-48;
							
						tamp3 = tamp1 << 4;
						tamp3 = tamp3 | tamp2;
			
						PORTB = tamp3;
						valPORTB = tamp3;
					
			
						if (data[3]-48 > 9)
							tamp1 = data[3]-55;	// ho una lettera
						else
							tamp1 = data[3]-48;
				
						if (data[4]-48 > 9)
							tamp2 = data[4]-55; // ho una lettera
						else
							tamp2 = data[4]-48;

						tamp3 = tamp1 << 4;
						tamp3 = tamp3 | tamp2;
			
						PORTD = tamp3;
						valPORTD = tamp3;								
					}
					
				if (data[0] == 'R')			//Lettura PORTB e PORTD
					{	
						//leggo il valore di PORTB e lo converto in esadecimale
			
						tamp1 = (valPORTB & 0b11110000);
						tamp1 = tamp1 >> 4;
						if (tamp1>9)	
							tamp2 = tamp1 + 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
									
						WriteUSART(tamp2);  	// trasmetto i 4 bit pi significativi del dato letto
						while (BusyUSART());	// attendo che il dato venga trasmesso
			
						tamp1 = (valPORTB & 0b00001111);
						
						if (tamp1>9)
							tamp2 = tamp1+ 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
							
						WriteUSART(tamp2);  	// trasmetto i 4 bit meno significativi del dato letto
						while (BusyUSART());	// attendo che il dato venga trasmesso

						//leggo il valore di PORTD e lo converto in esadecimale
						
						tamp1 = (valPORTD & 0b11110000);
						tamp1 = tamp1 >> 4;
						
						if (tamp1>9)	
							tamp2 = tamp1 + 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
									
						WriteUSART(tamp2);  	// trasmetto i 4 bit pi significativi del dato letto
						while (BusyUSART());	// attendo che il dato venga trasmesso
			
						tamp1 = (valPORTD & 0b00001111);
						
						if (tamp1>9)
							tamp2 = tamp1 + 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
							
						WriteUSART(tamp2);  	// trasmetto i 4 bit meno significativi del dato letto
						while (BusyUSART());	// attendo che il dato venga trasmesso
						
						WriteUSART(13);			// invio carattere ritorno a capo										
					}	 	
	 			 		
	 		counter = 0;	 			 			 	
	 	} 	 		 		
  		PIR1bits.RCIF = 0;		
	}
	
	
	if (INTCONbits.TMR0IF == 1 )	// Controllo che l'interrupt sia stato generato da TMR0 
	{		
 		num++;
 
  		if (num == 200)
  		{  
  			if (counter > 0)		// se non ricevo altri byte enro 4 secondi riazzero il contatore byte
  				{
  					ResetUSART++;
  					if  (ResetUSART = 100)
  						{	
  							counter = 0;
  							ResetUSART = 0;
  							beep ();
  						}
  				}  			
  		}  		  		
		INTCONbits.TMR0IF = 0;			
	}
 }


 void main (void)
 {
 	TRISA = 0xFF; 		// inizializzazione PORTA

 	TRISB = 0b00000000; // inizializzazione PORTB
 	PORTB = 0x00 ;

 	TRISC = 0b10100000; // inizializzazione PORTC
 	PORTC = 0x00;

 	TRISD = 0b00000000; // inizializzazione PORTD
 	PORTD = 0x00;

 	TRISE = 0x00; 		// inizializzazione PORTE
 	PORTE = 0x00;
 	
 	//inizializzo le varie periferiche interne al PIC
	
	OpenTimer0 (TIMER_INT_ON & T0_SOURCE_INT & T0_16BIT );	//contatore uso generale
	
	// Configura l'USART
	// 8 bit
	// 19200 bit/s
	// 1 bit stop
	// 0 bit parita'
	
	OpenUSART( USART_TX_INT_OFF &
	USART_RX_INT_ON &
	USART_ASYNCH_MODE &
	USART_EIGHT_BIT &
	USART_CONT_RX &
	USART_BRGH_HIGH,
	64 ); 
	
	INTCONbits.PEIE = 1 ;  	// abilito interrupt per periferiche
 	INTCONbits.GIE = 1; 	// abilito l'interrupt globale
  	
	beep ();	//segnalo l'attivazione del sistema

 	while (1); //ciclo infinito in attesa d'interrupt
 }
